import java.util.*;
import java.text.*;
import java.io.*;
/**
 * The user interface to the showboat application
 * 
 * @author Jens Bennedsen 
 * @version 20 April 2001
 * modified 20 April 2008 by mec
 */

class Showboat {
    
    private Showboat() {}
    
    /** The "menu" of the showboat system
      */
    public static void run() {
        char command= '.';
        command= getChar();
        while (command != '.' ) {
            if (command == 's')
                f.beginSession();
            if (command == 'e')
                f.endSession();
            command= getChar();
        }
        printDailyReport(f.doDailyReport());
    }
    
    
    private static void printDailyReport(ReportInfo r) {
        Calendar today = new GregorianCalendar();
        int day= today.get(Calendar.DAY_OF_MONTH);
        int month= today.get(Calendar.MONTH)+1;
        int year= today.get(Calendar.YEAR);
        String[] monthStr= {"", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
        String dateOut= day + " " + monthStr[month] + " " + year;
        
        int hour= today.get(Calendar.HOUR_OF_DAY);
        String hourStr;
        if ( hour < 10 ) hourStr= "0" + hour; else hourStr= "" + hour;
        int minute= today.get(Calendar.MINUTE);
        String minuteStr;
        if ( minute < 10 ) minuteStr= "0" + minute; else minuteStr= "" + minute;
        String timeOut = hourStr + ":" + minuteStr;
        
        
        System.out.println();
        System.out.println("*************************************");
        System.out.println("*      S H O W B O A T   Inc        *");
        System.out.println("*************************************");
        System.out.println("Daily Report    " + dateOut + "     " + timeOut);
        System.out.println("                                     ");
        System.out.print("Number of Sessions:                 ");
        System.out.println(r.getNrOfSessions());
        System.out.print("Average rental time:         ");
        System.out.println(r.getAvgTime());
        System.out.println("*************************************");
        System.out.println();
    }
    
    //The functions that the user can use
    private static Functions f = new Functions();
    
    /* ******************************************* */
    /* **********  Basic I/O Functions  ********** */
    /* ******************************************* */
    
    private static char getChar() {
        char inputString []= new char[2];
        Reader in= new InputStreamReader(System.in);
        
        System.out.print("(S, E, .)? ");
        try {
            in.read(inputString);
        } catch (java.io.IOException e) { }
        return inputString[0];
    }
    
    private static int getInt() {
        char inputString []= new char[10];
        Reader in= new InputStreamReader(System.in);
        int nr= 0;
        
        System.out.print("(Nr)? ");
        try {
            in.read(inputString); int k= 0;
            while ( Character.isDigit(inputString[k]) ) {
                nr= 10*nr + Character.getNumericValue(inputString[k]);
                k++;
            }
        } catch (java.io.IOException e) { }
        return nr;
    }
}