import java.util.*;
/**
 * An instance represents time of a day
 * 
 * @author Michael E. Caspersen, Jens Bennedsen   
 * @version 20 April 2001 <br>
 * Revision: <br>
 * 22 December 1998: Greather than added <br>
 * 20 April 2001: Javadoc added, The use of Date removed by using Calendar
 * 26 April 2009: Gries
 */
public class Time {
    //the hours. In range 0..23  
    private int h;
    
    //the minutes of the hour. In range 0..59
    private int m;
    
    //the seconds of the minute: In range 0..59
    private int s;
    
    /** Constructor: a time of x seconds.
        Precondition: x in 0..24*60*60-1*/
    public Time(int x) {
        h= x/3600;
        x= x%3600;
        m= x/60;
        s= x%60;
    }
    
    /** Constructor: a period with the current time. */
    public Time () {
        Calendar now= new GregorianCalendar();
        h= now.get(Calendar.HOUR);
        m= now.get(Calendar.MINUTE);
        s= now.get(Calendar.SECOND);
    }
    
    /** Set this time to h hours, m minutes, and s seconds.
      Precondition: h in 0..23, m in 0..59, s in 0..59. */
   // public void set (int h, int m, int s) {
    //    this.h= h;
    //    this.m= m;
    //    this.s= s;
    //}
    
    /** =  a new Time whose time is the sum of this time and t. */
    public Time add (Time t) {
        return new Time((s + m*60 + h*3600) + (t.s + t.m*60 + t.h*3600));
    }
    
    /** =  a new Time whose time is this time minus t.
        Precondition: t is >= this time.  */
    public Time subtract (Time t) {
        return new Time((s + m*60 + h*3600) - (t.s + t.m*60 + t.h*3600));
        
    }
    
    /** = a new Time whose time is this time divided by n.
        Precondition: n > 0. */
    public Time divide (int n) {
        return new Time((s + m*60 + h*3600)/n);
    }
    
    /** = "t is a Time and its time equals this Time's time.  */
    public boolean equals(Object t) {
        return t instanceof Time && 
               h == ((Time)t).h  &&  m == ((Time)t).m  &&  s == ((Time)t).s;
    }
    
    /** = t comes after this time.     */
    public boolean greaterThan (Time t) {
        if (h > t.h) return true;
        if (h < t.h) return false;
        
        // h = t.h
        if (m > t.m) return true;
        if (m < t.m) return false;
        
        // h = t.h  and m = t.m
        return s > t.s;
    }
    
    /** = representation of this time. with each part being 2 digits. */
    public String toString () {
        String hh= (h < 10 ? "0" : "") + h;
        String mm= (m < 10 ? "0" : "") + m;
        String ss= (s < 10 ? "0" : "") + s;

        return hh  +  ":"  +  mm  +  ":"  +  ss;
    }
    
    
}